{ Testing the wDraw3DFrame.pp unit.
  Drawing of objects in the 3D space.
  You can see a projection of them on the screen, of if you use
  Red and Green galsses, you can see them in the space, behind or
  in front of the screen.
  The colors can be changed in the program.
     Many different Bodies can be defines and viewed.
  --------------------------------------------}
program tEx057;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses

  wApplication0
 ,wWindow0
 ,wWindowBase0
 ,wVariableNumLink2
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wUtiles0
 ,wDraw3DFrame0
 ,wDraw3DFrame2
 ,xVectR3
 ,wMessages2
 ,wGlobals2
 ,wDebug0
 ,Windows;

type
  myPDraw3DFrame = ^myTDraw3DFrame;
  myTDraw3DFrame = object(TDraw3DFrame)
  //"""""""""""""""""""""""""""""""""""
  constructor Init(poParentW:PWindowBase0);

  function CtrlWindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the window messages
  // A SendMessage(hWin, ...) must not be called from here,
  // to avoid calling loops. (SendMessage(hWin...) calls this function
  end; // myTDraw3DFrame = object(TDraw3DFrame)

  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  poDraw3D : myPDraw3DFrame;

  MAXFACES,  // Maximum number of faces to put in the space world
  MAXPOINTS  // Maximum number of points to put in the space world
             : word32;

  vecNewCenterPos : RVectR3Float;
  // To translate each new body, and place them on a line

  constructor Init(strWinTitlePrm:ShortString);
  destructor Done; virtual;
  procedure WinCreate(strWinClass:ShortString); virtual;

  procedure NewSpaceWorld;

  procedure FinalBodySetup;

  procedure ASurface;
  procedure ATorus;
  procedure AnEllipsoide;
  procedure ACube;
  procedure ATwistedTorus;
  procedure AMobiusRibbon;
  procedure ASpecialTorus;
  procedure SimpleSphere;
  procedure SimpleTetrahedron;
  procedure SimpleCube;
  procedure SimpleCubeFull;   // Faces are squares !
  procedure TruncatedCubeEdges; // Edges of a Truncated cube !
  procedure SimpleOctahedron;
  procedure SimpleDodecahedron;
  procedure SimpleIcosahedron;
  procedure TruncatedCubeFull;
  procedure TruncatedTetrahedronFull;
  procedure TruncatedOctahedronFull;
  procedure SnubCubeFull;

  procedure TestZ; // To test special cases

  procedure ToggleView3D(fRedrawP:boolean);
  // Change the 3D viewing, with glasses or without glasses
  // Can be done with the contextual menu (Right click) also

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;

// var nNotUsed : integer; // only to avoid an error message while compliling in DevPascal 1.9

constructor myTDraw3DFrame.Init(poParentW:PWindowBase0);
//======================================================
begin
inherited Init(poParentW);
end; // myTDraw3DFrame.init

function myTDraw3DFrame.CtrlWindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//================================================================================================
// Handles the window messages
// A SendMessage(hWin, ...) must not be called from here,
// to avoid calling loops. (SendMessage(hWin...) calls this function
//var
//  fShiftDown  : boolean; // Is shift down?
//  fCtrlDown   : boolean; // Is Control down?

begin
if (wMsg = WM_Char) then begin
//   fCtrlDown:=(GetAsyncKeyState(VK_CONTROL) < 0);
//   fShiftDown:=(GetAsyncKeyState(VK_SHIFT) < 0);

   // if  'p'  is pressed, then
   //   if a body is selected and can be modified, then modify it.
   if (wPar = ord('p')) then begin
      if (wBodySelected > 0) then begin
         papoBodies^[wBodySelected]^.lUserData:=papoBodies^[wBodySelected]^.lUserData - 1;

         // beep if the size is the correcte one
         if (papoBodies^[wBodySelected]^.lUserData = 0) then MessageBeep(0);

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11031)) then
             poMyMainWin^.TruncatedCubeFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11032)) then
             poMyMainWin^.TruncatedTetrahedronFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11033)) then
             poMyMainWin^.TruncatedOctahedronFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11034)) then
             poMyMainWin^.SnubCubeFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11131)) then
             poMyMainWin^.TruncatedCubeEdges;

         end;
      end
   else if (wPar = ord('P')) then begin
      if (wBodySelected > 0) then begin
         papoBodies^[wBodySelected]^.lUserData:=papoBodies^[wBodySelected]^.lUserData + 1;

         // beep if the size is the correcte one
         if (papoBodies^[wBodySelected]^.lUserData = 0) then MessageBeep(0);

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11031)) then
             poMyMainWin^.TruncatedCubeFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11032)) then
             poMyMainWin^.TruncatedTetrahedronFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11033)) then
             poMyMainWin^.TruncatedOctahedronFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11034)) then
             poMyMainWin^.SnubCubeFull;

         if (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11131)) then
             poMyMainWin^.TruncatedCubeEdges;

         end;
      end;
   end;

CtrlWindowProc:=inherited CtrlWindowProc(hWindow, wMsg, wPar, lPar);
end; // myTDraw3DFrame.CtrlWindowProc

////////////////////////////////////////////////////////////////////////////////

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================
begin
inherited Init(strWinTitlePrm);

// To have a default at starting
MAXFACES  := 20100;
MAXPOINTS := 21000;

new(poDraw3D, Init(@Self));

poDraw3D^.colorRightEye.wColor :=RGB(255,  0,  0); // Red
poDraw3D^.colorLeftEye.wColor  :=RGB(  0, 90,  90); // Light Green


vecNewCenterPos:=gglvecV3Zero;

// This line is all what is needed to have a status line.
new(poStatusLine, Init(@Self));
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//=========================
begin
// Do not dispose poDraw3D, already done by the parent
inherited Done;
end;  // TMyWindow.Done

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
// Create the window, and insert an edit box and a status line in it.
var wErrorL : word32;
begin
inherited WinCreate(strWinClass);

// definitions of the key
if ExistMsgNumber(13000) then with poDraw3D^ do begin
  // Defines the key corresponding rotation or translation axis. Of the viewer !
  wVXTS:=GetMsgWordValue(msgNext);  //  VK_Y;  DBW(0, WTS(wVXTS) + '  ' + WTS(VK_Y));
  wVYTS:=GetMsgWordValue(msgNext);  //  VK_X;
  wVZTS:=GetMsgWordValue(msgNext);  //  VK_C;  //  X = direction,  T = Translation,  S = Screen coordinates.
  wVXTB:=GetMsgWordValue(msgNext);  //  VK_V;
  wVYTB:=GetMsgWordValue(msgNext);  //  VK_B;
  wVZTB:=GetMsgWordValue(msgNext);  //  VK_N;  //  X = direction,  T = Translation,  B = Body coordinates.
  wVXTA:=GetMsgWordValue(msgNext);  //  VK_M;
  wVYTA:=GetMsgWordValue(msgNext);  //  188;   //  188 = ","  conlon,  190 = "." dot  on the swiss keyboard.
  wVZTA:=GetMsgWordValue(msgNext);  //  190;   //  X = direction,  T = Translation,  A = Axis coordinates. (shown on the screen)

  wVXRS:=GetMsgWordValue(msgNext);  //  VK_A;
  wVYRS:=GetMsgWordValue(msgNext);  //  VK_S;
  wVZRS:=GetMsgWordValue(msgNext);  //  VK_D;  //  X = direction,  R = Rotation,     S = Screen coordinates.
  wVXRB:=GetMsgWordValue(msgNext);  //  VK_F;
  wVYRB:=GetMsgWordValue(msgNext);  //  VK_G;
  wVZRB:=GetMsgWordValue(msgNext);  //  VK_H;  //  X = direction,  R = Rotation,     B = Body coordinates.
  wVXRA:=GetMsgWordValue(msgNext);  //  VK_J;
  wVYRA:=GetMsgWordValue(msgNext);  //  VK_K;
  wVZRA:=GetMsgWordValue(msgNext);  //  VK_L;   //  X = direction,  R = Rotation,    A = Axis coordinates.

  // Defines the key corresponding rotation or translation axis. Of the Body !
  wBXTS:=GetMsgWordValue(msgNext);  //  VK_Q;
  wBYTS:=GetMsgWordValue(msgNext);  //  VK_W;
  wBZTS:=GetMsgWordValue(msgNext);  //  VK_E;  //  X = direction,  T = Translation,  S = Screen coordinates.
  WBXTB:=GetMsgWordValue(msgNext);  //  VK_R;
  wBYTB:=GetMsgWordValue(msgNext);  //  VK_T;
  wBZTB:=GetMsgWordValue(msgNext);  //  VK_Z;  //  X = direction,  T = Translation,  B = Body coordinates.
  wBXTA:=GetMsgWordValue(msgNext);  //  VK_U;
  wBYTA:=GetMsgWordValue(msgNext);  //  VK_I;
  wBZTA:=GetMsgWordValue(msgNext);  //  VK_O;  //  X = direction,  T = Translation,  A = Axis coordinates. (shown on the screen)

  wBXRS:=GetMsgWordValue(msgNext);  //  VK_1;
  wBYRS:=GetMsgWordValue(msgNext);  //  VK_2;
  wBZRS:=GetMsgWordValue(msgNext);  //  VK_3;  //  X = direction,  R = Rotation,     S = Screen coordinates.
  wBXRB:=GetMsgWordValue(msgNext);  //  VK_4;
  wBYRB:=GetMsgWordValue(msgNext);  //  VK_5;
  wBZRB:=GetMsgWordValue(msgNext);  //  VK_6;  //  X = direction,  R = Rotation,     B = Body coordinates.
  wBXRA:=GetMsgWordValue(msgNext);  //  VK_7;
  wBYRA:=GetMsgWordValue(msgNext);  //  VK_8;
  wBZRA:=GetMsgWordValue(msgNext);  //  VK_9;   //  X = direction,  R = Rotation,    A = Axis coordinates.
  end; // with poDraw3D^

poDraw3D^.nYSizePix:=poDraw3D^.nYSizePix - int32(poStatusLine^.wHeight);
poDraw3D^.CtrlCreate;
SetFocus(poDraw3D^.hWin);

// Allocate memory for 11000 points and 10100 faces
poDraw3D^.AllocateMemory(MAXPOINTS, MAXFACES, wErrorL); // Hope there is no errors

// Viewing position and screen center in centimeters
// This defines also the distance between the viwer and the screen
poDraw3D^.Draw3DSetup(-9.0, -78.0, 10.0, 0, 0, 0); // Screen at (0,0,0)
end;  // TMyWindow.WinCreate

procedure TMyWindow.NewSpaceWorld;
//================================
// Clear the actual object in the space, define the maximum number of
// points and face, and reset all
var
  wMAXPOINTSNew,
  wMAXFACESNew,
  wErrorL : word32;
  nRep    : integer;
  vMemSize : Float; // Memory space allocated to store the points and faces

begin
// To define a new number of points and faces
wMAXPOINTSNew:=MAXPOINTS;
wMAXFACESNew :=MAXFACES;
Word32Field(1001, wMAXFACESNew);
Word32Field(1002, wMAXPOINTSNew);
Word32Field(1011, MAXFACES);
Word32Field(1012, MAXPOINTS);
FloatField( 1003, vMemSize);

// Last size of memory allocated
vMemSize:=(MAXPOINTS * SizeOf(TypePoint3D) +
           MAXFACES * SizeOf(TypeFace3D)) / 1000000.0;

nRep:=DialogExecMSG(12299, @Self);

if (nRep <> IDOK) then exit;

vMemSize:=(wMAXPOINTSNew * SizeOf(TypePoint3D) +
           wMAXFACESNew * SizeOf(TypeFace3D)) / 1000000.0;
if (vMemSize > 50) then begin
    // Very big amount of space, ask confirmation
   nRep:=DialogExecMSG(12399, @Self);

   if (nRep <> IDOK) then exit;
   end;

// Only here, accept the modifications
MAXPOINTS:=wMAXPOINTSNew;
MAXFACES :=wMAXFACESNew;

// Dispose the actual space world
dispose(poDraw3D, Done);
vecNewCenterPos:=gglvecV3Zero;

// create a new one
new(poDraw3D, Init(@Self));

// Size on the screen
poDraw3D^.nYSizePix:=poDraw3D^.nYSizePix - int32(poStatusLine^.wHeight);

// Create the corresponding control (A very sofisticated control !)
poDraw3D^.CtrlCreate;
SetFocus(poDraw3D^.hWin);

// Allocate memory for 11000 points and 10100 faces
poDraw3D^.AllocateMemory(MAXPOINTS, MAXFACES, wErrorL); // Hope there is no errors

// Viewing position and screen center in centimeters
// This defines also the distance between the viwer and the screen
poDraw3D^.Draw3DSetup(-9.0, -78.0, 10.0, 0, 0, 0); // Screen at (0,0,0)
end;  // TMyWindow.NewSpaceWorld

procedure TMyWindow.FinalBodySetup;
//=================================
begin
with poDraw3D^ do begin
   // This defines the number of points and faces in the Body
   // It defines also the colors. Must be called.
   papoBodies^[wNumBodies]^.BodySetup(0,0,0);

   // Positionning of the Body (must be called after the Body Setup
   papoBodies^[wNumBodies]^.BodySetPosition(vecNewCenterPos);

   vecNewCenterPos:=vecNewCenterPos + V3Assign(-14.0, 0, 0); // [cm]

   // This defines the rotation center
   vecRotationCenter :=papoBodies^[wNumBodies]^.vecGravityCenter;

   // Define the Position of the screen in the space.
   // This doesn't change the viewing direction, and moves the viewer.
//   SetScreenCenter(vecCenterGravity);

   // Define the viewing direction, without modifying the viewer position
   // Sets again the right horizontal.
   SetViewDirection(vecRotationCenter);
   end; // with
end;  // TMyWindow.FinalBodySetup

procedure TMyWindow.ASurface;
//===========================
const
  nMinX =-15;
  nMaxX = 15;
  nMinY =-15;
  nMaxY = 15;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  prPtOrg,    // point corresponding to the origine
  prPtX,      // point (1,0,0)
  prPtY,      // point (0,1,0)
  prPtZ       // point (0,0,1)
              : PTypePoint3D;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = centimeters
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      // Add one point
      with parPtsL^[(nX-nMinX)*nDY + nY-nMinY] do begin
         vecV[1]:=nX / Float(nMaxX); // in [-1..1]
         vecV[2]:=nY / Float(nMaxY); // in [-1..1]
         vecV[3]:=exp(-(3*sqr(vecV[1]-0.6) + 9*sqr(vecV[2]-0.25)));
         vecV:=5.0*vecV;
         end; // with
      end;

   wNumPoints:=wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Add some points to draw the axis
   inc(wNumPoints);   prPtOrg:=@parPoints^[wNumPoints];
   with parPoints^[wNumPoints] do begin
      vecV[1]:=0;  vecV[2]:=0;  vecV[3]:=0;
      end; // with

   inc(wNumPoints);   prPtX:=@parPoints^[wNumPoints];
   with parPoints^[wNumPoints] do begin
      vecV[1]:=15;  vecV[2]:=0;  vecV[3]:=0;
      end; // with

   inc(wNumPoints);   prPtY:=@parPoints^[wNumPoints];
   with parPoints^[wNumPoints] do begin
      vecV[1]:=0;  vecV[2]:=15;  vecV[3]:=0;
      end; // with

   inc(wNumPoints);   prPtZ:=@parPoints^[wNumPoints];
   with parPoints^[wNumPoints] do begin
      vecV[1]:=0;  vecV[2]:=0;  vecV[3]:=15;
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=prPtOrg;  aprPoint[2]:=prPtX;
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=prPtOrg;  aprPoint[2]:=prPtY;
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=prPtOrg;  aprPoint[2]:=prPtZ;
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=FALSE; // Ask to have two colors
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,  0);
   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(128,128,  0);
   papoBodies^[wNumBodies]^.colorAx.wColor :=RGB(  0,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11001); // A Surface;

   // To view in 3D, with Red - Green glasses (Can be acceded from the menu
//   poDraw3D^.fView3DWithGalsses:=FALSE;  ToggleView3D(FALSE); // Set the right bookmark

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // erase window, and draw
   Draw3DBodies;
   end; // with
end;  // TMyWindow.ASurface

procedure TMyWindow.ATorus;
//=========================
// A torus
const
  nMinX =0;
  nMaxX =30;
  nMinY =0;
  nMaxY =30;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=2*Pi*nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=2*Pi*nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         vecV[1]:=3.0 + 1.2*Cos(vPhi);
         vecV[2]:=0.0;
         vecV[3]:=      1.2*Sin(vPhi);
         vecV:=0.9*V3RotationOrg(vecV, V3Assign(0,0,1), -vTheta);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,128,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11002); // A Torus

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.ATorus

procedure TMyWindow.AnEllipsoide;
//===============================
const
  nMinX =0;
  nMaxX =30;
  nMinY =0;
  nMaxY =30;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=2*Pi*nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=2*Pi*nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         vecV[1]:=2.0*Cos(vPhi) * Cos(vTheta);
         vecV[2]:=2.2*Sin(vPhi) * Cos(vTheta);
         vecV[3]:=6.0*            Sin(vTheta);
//          vecV:=V3RotationOrg(vecV, V3Assign(0,1,0), 70*pi/180);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(64,255,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11003); // An Ellipsoid

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.AnEllipsoide

procedure TMyWindow.ACube;
//========================
// A cube
const
  nMinX =0;
  nMaxX =5;
  nMinY =0;
  nMaxY =20;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=1.0* nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=4.0* nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         if (vTheta <= 1) then begin
            vecV[1]:=vTheta;
            vecV[2]:=0;
            end
         else if (vTheta <= 2) then begin
            vecV[1]:=1;
            vecV[2]:=vTheta -1;
            end
         else if (vTheta <= 3) then begin
            vecV[1]:=3-vTheta;
            vecV[2]:=1;
            end
         else begin
            vecV[1]:=0;
            vecV[2]:=4-vTheta;
            end;

         vecV[3]:=1.0-vPhi;
         vecV:=4*vecV;

         // It is better to rotate the Body after the Setup bellow
         // This will rotate its orientations axes too.
         // vecV:=4*V3RotationOrg(vecV, V3Assign(0,1,0), 40*pi/180);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=FALSE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,64,255);
   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(  0,64,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11004); // A Cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
   papoBodies^[wNumBodies]^.BodyRotateGC(V3Assign(0,1,0), 40*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.ACube

procedure TMyWindow.ATwistedTorus;
//========================
// A twisted torus
const
  nMinX =0;
  nMaxX =30;
  nMinY =0;
  nMaxY =30;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=2*Pi*nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=2*Pi*nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         vecV[1]:=3.0 + 1.2*Cos(vPhi+vTheta);
         vecV[2]:=0.0;
         vecV[3]:=      1.2*Sin(vPhi+vTheta);
         vecV:=0.9*V3RotationOrg(vecV, V3Assign(0,0,1), -vTheta);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11005); // A twited Torus

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the torus
   Draw3DBodies;
   end; // with
end;  // TMyWindow.ATwistedTorus

procedure TMyWindow.AMobiusRibbon;
//================================
// A Mobius Ribbon
const
  nMinX = 0;
  nMaxX =30;
  nMinY = 0;
  nMaxY = 4;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=2*Pi*nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=2*Pi*nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         vecV[1]:=((vTheta-Pi)/2)*Cos(vPhi);
         vecV[2]:=((vTheta-Pi)/2)*Sin(vPhi);
         vecV[3]:=0.0;
         vecV:= V3RotationOrg(vecV, V3Assign(-Sin(vPhi), Cos(vPhi), 0), vPhi/2) +
                V3Assign(4*Cos(vPhi), 4*Sin(vPhi), 0.0);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=FALSE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11006); // A Mobius Ribbon

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.AMobiusRibbon

procedure TMyWindow.ASpecialTorus;
//================================
// A torus
const
  nMinX =0;
  nMaxX =15;
  nMinY =0;
  nMaxY =60;
  nDY   = 1 + nMaxY - nMinY;
var
  nX,nY       : int32;
  vPhi,vTheta : Float;
  parPtsL     : PArrayPoint3D;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + word32((nMaxX-nMinX)*nDY + nMaxY-nMinY) +5 > MAXPOINTS) or
      (wNumFaces  + word32((nMaxX-nMinX)*(nMaxY-nMinY)) + 4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=nMinX to nMaxX do
   for nY:=nMinY to nMaxY do begin
      vPhi   :=2*Pi*nX / Float(nMaxX); // in [0..2*Pi]
      vTheta :=2*Pi*nY / Float(nMaxY); // in [0..2*Pi]
      // Add one point
      with parPtsL^[nX*nDY + nY] do begin
         vecV[1]:=(4.0 + 1.2*cos(3*vTheta)) + 0.7*Cos(vPhi+5*vTheta);
         vecV[2]:=0.0;
         vecV[3]:=      0.7*Sin(vPhi+5*vTheta) + 1.3*sin(3*vTheta);
         vecV:=0.9*V3RotationOrg(vecV, V3Assign(0,0,1), -2*vTheta);
         end; // with
      end;

   wNumPoints:=wNumPoints + (nMaxX-nMinX)*nDY + nMaxY-nMinY +1;

   // Add the faces
   for nX:=nMinX to nMaxX-1 do
   for nY:=nMinY to nMaxY-1 do begin
      inc(wNumFaces);
      with parFaces^[wNumFaces] do begin
         nNbPoint:=4;
         aprPoint[1]:=@parPtsL^[(  nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[2]:=@parPtsL^[(1+nX-nMinX)*nDY +   nY-nMinY];
         aprPoint[3]:=@parPtsL^[(1+nX-nMinX)*nDY + 1+nY-nMinY];
         aprPoint[4]:=@parPtsL^[(  nX-nMinX)*nDY + 1+nY-nMinY];
         end; // with
      end; // for

   // Optional, defining the colors
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(128,255, 92);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11007); // A Special Torus

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.ASpecialTorus

procedure TMyWindow.SimpleSphere;
//===============================
// A simple Sphere,  Faces are in reality the edges
var
  nx          : integer;
  parPtsL     : PArrayPoint3D;
  vPhi,
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + 3*32 > MAXPOINTS) or
      (wNumFaces  + 3*32 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=6.0; // [cm]
   vSizeL  :=vRadiusL;

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   for nX:=0 to 32 do begin
      vPhi:=Pi * nX / 16.0;
      parPtsL^[nX].vecV:=vSizeL * V3Assign(cos(vPhi),sin(vPhi),0);
      inc(wNumPoints);

      if (nX < 32) then begin
         // Add the "faces", i.e. the edges
         inc(wNumFaces);
         with parFaces^[wNumFaces] do begin
            nNbPoint:=2;  aprPoint[1]:=@parPtsL^[nX];  aprPoint[2]:=@parPtsL^[nX+1];
            end; // with
         end;
      end; // for

   parPtsL:=@parPoints^[wNumPoints+1];

   // Add the points. Units = cm
   for nX:=0 to 32 do begin
      vPhi:=Pi * nX / 16.0;
      parPtsL^[nX].vecV:=vSizeL * V3Assign(cos(vPhi), 0, sin(vPhi));
      inc(wNumPoints);

      if (nX < 32) then begin
         // Add the "faces", i.e. the edges
         inc(wNumFaces);
         with parFaces^[wNumFaces] do begin
            nNbPoint:=2;  aprPoint[1]:=@parPtsL^[nX];  aprPoint[2]:=@parPtsL^[nX+1];
            end; // with
         end;
      end; // for

   parPtsL:=@parPoints^[wNumPoints+1];

   // Add the points. Units = cm
   for nX:=0 to 32 do begin
      vPhi:=Pi * nX / 16.0;
      parPtsL^[nX].vecV:=vSizeL * V3Assign(0,cos(vPhi),sin(vPhi));
      inc(wNumPoints);

      if (nX < 32) then begin
         // Add the "faces", i.e. the edges
         inc(wNumFaces);
         with parFaces^[wNumFaces] do begin
            nNbPoint:=2;  aprPoint[1]:=@parPtsL^[nX];  aprPoint[2]:=@parPtsL^[nX+1];
            end; // with
         end;
      end; // for

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB( 64,128,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11010); // A simple Sphere

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleSphere

procedure TMyWindow.SimpleTetrahedron;
//====================================
// Faces are in reality the edges
var
  parPtsL     : PArrayPoint3D;
  vXL,vYL,vZL,
//  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  4 > MAXPOINTS) or
      (wNumFaces  +  6 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=6.0; // [cm]
//   vSizeL  :=sqrt(3) * vRadiusL;

   // Coordonate of the points of a Tetrahedron
   vXL:=(sqrt(2)/3) * vRadiusL;
   vYL:=(sqrt(2/3)) * vRadiusL;
   vZL:=      (4/3) * vRadiusL;

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   parPtsL^[0].vecV:=V3Assign(2*vXL,   0, -vZl/4);
   parPtsL^[1].vecV:=V3Assign( -vXL, vYL, -vZl/4);
   parPtsL^[2].vecV:=V3Assign( -vXL,-vYL, -vZl/4);
   parPtsL^[3].vecV:=V3Assign(    0,   0,3*vZL/4);

   wNumPoints:=wNumPoints + 4;

   // Add the "faces", i.e. the 6 edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[2];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11011); // A simple Tetrahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleTetrahedron

procedure TMyWindow.SimpleCube;
//=============================
// Faces are in reality the edges
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  poBodyEdgeCreator : PBody3DEdgesCreator;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  208 > MAXPOINTS) or
      (wNumFaces  + 206 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=4.0; // [cm]
   vSizeL  :=vRadiusL;

   // Creates a new body
//   inc(wNumBodies);
//   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   parPtsL^[200].vecV:=vSizeL * V3Assign(-1,-1,-1);
   parPtsL^[201].vecV:=vSizeL * V3Assign( 1,-1,-1);
   parPtsL^[202].vecV:=vSizeL * V3Assign(-1, 1,-1);
   parPtsL^[203].vecV:=vSizeL * V3Assign(-1,-1, 1);
   parPtsL^[204].vecV:=vSizeL * V3Assign( 1, 1,-1);
   parPtsL^[205].vecV:=vSizeL * V3Assign( 1,-1, 1);
   parPtsL^[206].vecV:=vSizeL * V3Assign(-1, 1, 1);
   parPtsL^[207].vecV:=vSizeL * V3Assign( 1, 1, 1);

//   wNumPoints:=wNumPoints + 8;

   with parFaces^[wNumFaces+200] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[200];  aprPoint[2]:=@parPtsL^[201];
                    aprPoint[3]:=@parPtsL^[204];  aprPoint[4]:=@parPtsL^[202];
      end; // with

   with parFaces^[wNumFaces+201] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[200];  aprPoint[2]:=@parPtsL^[201];
                    aprPoint[3]:=@parPtsL^[205];  aprPoint[4]:=@parPtsL^[203];
      end; // with

   with parFaces^[wNumFaces+202] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[200];  aprPoint[2]:=@parPtsL^[202];
                    aprPoint[3]:=@parPtsL^[206];  aprPoint[4]:=@parPtsL^[203];
      end; // with

   with parFaces^[wNumFaces+203] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[207];  aprPoint[2]:=@parPtsL^[205];
                    aprPoint[3]:=@parPtsL^[201];  aprPoint[4]:=@parPtsL^[204];
      end; // with

   with parFaces^[wNumFaces+204] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[207];  aprPoint[2]:=@parPtsL^[206];
                    aprPoint[3]:=@parPtsL^[202];  aprPoint[4]:=@parPtsL^[204];
      end; // with

   with parFaces^[wNumFaces+205] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[207];  aprPoint[2]:=@parPtsL^[206];
                    aprPoint[3]:=@parPtsL^[203];  aprPoint[4]:=@parPtsL^[205];
      end; // with

   //-----------------------------------------------------------
   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Creates a new body...
   new(poBodyEdgeCreator, init(poDraw3D));
   // given data :
   //=============
   with poBodyEdgeCreator^ do begin
     parPointsIn  :=@parPtsL^[200];
     wNumPointsIn :=8;
     parFacesIn   :=@parFaces^[wNumFaces+200];
     wNumFacesIn  :=6;

     parPointsOut :=@parPoints^[wNumPoints];

     parFacesOut  :=@parFaces^[wNumFaces];
     wMaxPointsOut:=200;
     wMaxFacesOut :=200;

     CreateFacesFromBody(0);
     wNumPoints   :=wNumPoints + wNumPointsOut;
     wNumFaces    :=wNumFaces + wNumFacesOut;
     end; // with

   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11012); // A simple Cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   dispose(poBodyEdgeCreator, done);

   // Erase the background and draw the Body
   Draw3DBodies;

   end; // with
end;  // TMyWindow.SimpleCube

procedure TMyWindow.SimpleCubeFull;
//=================================
// Faces are squares !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  8 > MAXPOINTS) or
      (wNumFaces  + 6 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=4.0; // [cm]
   vSizeL  :=(1/sqrt(3)) * vRadiusL;

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   parPtsL^[0].vecV:=vSizeL * V3Assign(-1,-1,-1); // 0
   parPtsL^[1].vecV:=vSizeL * V3Assign(-1,-1, 1); // 1
   parPtsL^[2].vecV:=vSizeL * V3Assign(-1, 1,-1); // 2
   parPtsL^[3].vecV:=vSizeL * V3Assign(-1, 1, 1); // 3
   parPtsL^[4].vecV:=vSizeL * V3Assign( 1,-1,-1); // 4
   parPtsL^[5].vecV:=vSizeL * V3Assign( 1,-1, 1); // 5
   parPtsL^[6].vecV:=vSizeL * V3Assign( 1, 1,-1); // 6
   parPtsL^[7].vecV:=vSizeL * V3Assign( 1, 1, 1); // 7

   wNumPoints:=wNumPoints + 8;

   // Add the "faces", i.e. the twelve edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[1];
      aprPoint[3]:=@parPtsL^[3];  aprPoint[4]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[5];
      aprPoint[3]:=@parPtsL^[7];  aprPoint[4]:=@parPtsL^[6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[1];
      aprPoint[3]:=@parPtsL^[5];  aprPoint[4]:=@parPtsL^[4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[2];  aprPoint[2]:=@parPtsL^[3];
      aprPoint[3]:=@parPtsL^[7];  aprPoint[4]:=@parPtsL^[6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[2];
      aprPoint[3]:=@parPtsL^[6];  aprPoint[4]:=@parPtsL^[4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=4;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[3];
      aprPoint[3]:=@parPtsL^[7];  aprPoint[4]:=@parPtsL^[5];
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11022); // A Cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleCubeFull

procedure TMyWindow.SimpleOctahedron;
//===================================
// Faces are in reality the edges
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  6 > MAXPOINTS) or
      (wNumFaces  + 12 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=6.0; // [cm]
   vSizeL  :=vRadiusL;

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   parPtsL^[0].vecV:=vSizeL * V3Assign( 1, 0, 0);
   parPtsL^[1].vecV:=vSizeL * V3Assign( 0, 1, 0);
   parPtsL^[2].vecV:=vSizeL * V3Assign(-1, 0, 0);
   parPtsL^[3].vecV:=vSizeL * V3Assign( 0,-1, 0);
   parPtsL^[4].vecV:=vSizeL * V3Assign( 0, 0, 1);
   parPtsL^[5].vecV:=vSizeL * V3Assign( 0, 0,-1);

   wNumPoints:=wNumPoints + 6;

   // Add the "faces", i.e. the twelve edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[0];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[0];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[2];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[3];  aprPoint[2]:=@parPtsL^[0];
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(255,128, 32);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11013); // A simple Octahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleOctahedron

procedure TMyWindow.SimpleDodecahedron;
//=====================================
// Faces are in reality the edges
var
  parPtsL     : PArrayPoint3D;
  vL,
  vPhi,
  vTheta,
  vSinPhi,
  vCosPhi,
  vSinPhiT,
  vCosPhiT,
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + 20 > MAXPOINTS) or
      (wNumFaces  + 30 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=6.0; // [cm]
   vSizeL  :=vRadiusL;

   vL       :=sqrt(5/3) - sqrt(1/3);
   vPhi     :=  ArcSin(vL / (2*Sin(35*Pi/180)));
   vTheta   :=2*ArcSin(vL / 2);
   vSinPhi  :=vL / (2*Sin(35*Pi/180));
   vCosPhi  :=Cos(vPhi);
   vSinPhiT :=Sin(vPhi+vTheta);
   vCosPhiT :=Cos(vPhi+vTheta);

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the 20 points. Units = cm
   parPtsL^[ 0].vecV:=vSizeL * V3Assign(-vSinPhi,               0,                           vCosPhi);
   parPtsL^[ 1].vecV:=vSizeL * V3Assign(-vSinPhi *cos( 72*Pi/180),-vSinPhi*sin( 72*Pi/180),  vCosPhi);
   parPtsL^[ 2].vecV:=vSizeL * V3Assign(-vSinPhi *cos(144*Pi/180),-vSinPhi*sin(144*Pi/180),  vCosPhi);
   parPtsL^[ 3].vecV:=vSizeL * V3Assign(-vSinPhi *cos(216*Pi/180),-vSinPhi*sin(216*Pi/180),  vCosPhi);
   parPtsL^[ 4].vecV:=vSizeL * V3Assign(-vSinPhi *cos(288*Pi/180),-vSinPhi*sin(288*Pi/180),  vCosPhi);
   parPtsL^[ 5].vecV:=vSizeL * V3Assign(-vSinPhiT               ,                         0, vCosPhiT);
   parPtsL^[ 6].vecV:=vSizeL * V3Assign(-vSinPhiT*cos( 72*Pi/180),-vSinPhiT*sin( 72*Pi/180), vCosPhiT);
   parPtsL^[ 7].vecV:=vSizeL * V3Assign(-vSinPhiT*cos(144*Pi/180),-vSinPhiT*sin(144*Pi/180), vCosPhiT);
   parPtsL^[ 8].vecV:=vSizeL * V3Assign(-vSinPhiT*cos(216*Pi/180),-vSinPhiT*sin(216*Pi/180), vCosPhiT);
   parPtsL^[ 9].vecV:=vSizeL * V3Assign(-vSinPhiT*cos(288*Pi/180),-vSinPhiT*sin(288*Pi/180), vCosPhiT);
   parPtsL^[10].vecV:=-1.0 * parPtsL^[ 9].vecV;
   parPtsL^[11].vecV:=-1.0 * parPtsL^[ 8].vecV;
   parPtsL^[12].vecV:=-1.0 * parPtsL^[ 7].vecV;
   parPtsL^[13].vecV:=-1.0 * parPtsL^[ 6].vecV;
   parPtsL^[14].vecV:=-1.0 * parPtsL^[ 5].vecV;
   parPtsL^[15].vecV:=-1.0 * parPtsL^[ 4].vecV;
   parPtsL^[16].vecV:=-1.0 * parPtsL^[ 3].vecV;
   parPtsL^[17].vecV:=-1.0 * parPtsL^[ 2].vecV;
   parPtsL^[18].vecV:=-1.0 * parPtsL^[ 1].vecV;
   parPtsL^[19].vecV:=-1.0 * parPtsL^[ 0].vecV;

   wNumPoints:=wNumPoints + 20;

   // Add the "faces", i.e. the 30 edges
   // The top Pentagone with 5 sides
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 0];  aprPoint[2]:=@parPtsL^[ 1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 1];  aprPoint[2]:=@parPtsL^[ 2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 2];  aprPoint[2]:=@parPtsL^[ 3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 3];  aprPoint[2]:=@parPtsL^[ 4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 4];  aprPoint[2]:=@parPtsL^[ 0];
      end; // with

   // Oblique 5 lines
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 0];  aprPoint[2]:=@parPtsL^[ 5];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 1];  aprPoint[2]:=@parPtsL^[ 6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 2];  aprPoint[2]:=@parPtsL^[ 7];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 3];  aprPoint[2]:=@parPtsL^[ 8];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 4];  aprPoint[2]:=@parPtsL^[ 9];
      end; // with

   // Near horizontal 10 lines
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 5];  aprPoint[2]:=@parPtsL^[11];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[ 6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 6];  aprPoint[2]:=@parPtsL^[10];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[10];  aprPoint[2]:=@parPtsL^[ 7];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 7];  aprPoint[2]:=@parPtsL^[14];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[14];  aprPoint[2]:=@parPtsL^[ 8];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 8];  aprPoint[2]:=@parPtsL^[13];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[13];  aprPoint[2]:=@parPtsL^[ 9];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[ 9];  aprPoint[2]:=@parPtsL^[12];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[12];  aprPoint[2]:=@parPtsL^[ 5];
      end; // with

   // Again 5 oblique lines
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[16];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[10];  aprPoint[2]:=@parPtsL^[15];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[14];  aprPoint[2]:=@parPtsL^[19];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[13];  aprPoint[2]:=@parPtsL^[18];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[12];  aprPoint[2]:=@parPtsL^[17];
      end; // with

   inc(wNumFaces);
   // The Bottom pentagone
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[15];  aprPoint[2]:=@parPtsL^[16];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[16];  aprPoint[2]:=@parPtsL^[17];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[17];  aprPoint[2]:=@parPtsL^[18];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[18];  aprPoint[2]:=@parPtsL^[19];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[19];  aprPoint[2]:=@parPtsL^[15];
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(  0,192,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11014); // A simple Dodecahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleDodecahedron

procedure TMyWindow.SimpleIcosahedron;
//====================================
// Faces are in reality the edges
var
  parPtsL     : PArrayPoint3D;
  vXL,vZL,
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + 12 > MAXPOINTS) or
      (wNumFaces  + 30 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   parPtsL:=@parPoints^[wNumPoints+1];

   // Size of an edge, in [cm]
   vRadiusL:=6.0; // [cm]
   vSizeL  :=vRadiusL;

   vXL:=2/sqrt(5);
   vZL:=1/sqrt(5);

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vSizeL * V3Assign(0,                0,                        1);
   parPtsL^[ 1].vecV:=vSizeL * V3Assign(vXL                ,                  0,  vZL);
   parPtsL^[ 2].vecV:=vSizeL * V3Assign(vXL*cos( 72*Pi/180),vXL*sin( 72*Pi/180),  vZL);
   parPtsL^[ 3].vecV:=vSizeL * V3Assign(vXL*cos(144*Pi/180),vXL*sin(144*Pi/180),  vZL);
   parPtsL^[ 4].vecV:=vSizeL * V3Assign(vXL*cos(216*Pi/180),vXL*sin(216*Pi/180),  vZL);
   parPtsL^[ 5].vecV:=vSizeL * V3Assign(vXL*cos(288*Pi/180),vXL*sin(288*Pi/180),  vZL);
   parPtsL^[ 6].vecV:=-1.0 * parPtsL^[ 1].vecV;
   parPtsL^[ 7].vecV:=-1.0 * parPtsL^[ 5].vecV;
   parPtsL^[ 8].vecV:=-1.0 * parPtsL^[ 4].vecV;
   parPtsL^[ 9].vecV:=-1.0 * parPtsL^[ 3].vecV;
   parPtsL^[10].vecV:=-1.0 * parPtsL^[ 2].vecV;
   parPtsL^[11].vecV:=-1.0 * parPtsL^[ 0].vecV;

   wNumPoints:=wNumPoints + 12;

   // Add the "faces", i.e. the 30 edges
   // The 5 top edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[0];  aprPoint[2]:=@parPtsL^[5];
      end; // with

   // The 5 top horizontal edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[2];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[3];  aprPoint[2]:=@parPtsL^[4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[5];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   // The ten zig-zag edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[1];  aprPoint[2]:=@parPtsL^[8];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[8];  aprPoint[2]:=@parPtsL^[2];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[2];  aprPoint[2]:=@parPtsL^[7];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[7];  aprPoint[2]:=@parPtsL^[3];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[3];  aprPoint[2]:=@parPtsL^[6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[6];  aprPoint[2]:=@parPtsL^[4];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[4];  aprPoint[2]:=@parPtsL^[10];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[10];  aprPoint[2]:=@parPtsL^[5];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[5];  aprPoint[2]:=@parPtsL^[9];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[9];  aprPoint[2]:=@parPtsL^[1];
      end; // with

   // The five bottom horizontal
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[6];  aprPoint[2]:=@parPtsL^[7];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[7];  aprPoint[2]:=@parPtsL^[8];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[8];  aprPoint[2]:=@parPtsL^[9];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[9];  aprPoint[2]:=@parPtsL^[10];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[10];  aprPoint[2]:=@parPtsL^[6];
      end; // with

   // The five bottom edges
   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[6];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[7];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[8];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[9];
      end; // with

   inc(wNumFaces);
   with parFaces^[wNumFaces] do begin
      nNbPoint:=2;  aprPoint[1]:=@parPtsL^[11];  aprPoint[2]:=@parPtsL^[10];
      end; // with

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB( 64,255, 64);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11015); // A simple Icosahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SimpleIcosahedron

procedure TMyWindow.TruncatedCubeFull;
//====================================
// Faces of a Truncated cube !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  vC          : Float; // for the coordinate of the vertices.
  fNewCreation : boolean;  // true if a new Truncated cube is created
  vecBodyVertZ_old,  //  actual body orientation
  vecBodyHorizX_old,
  vecGC        : RVectR3Float;  // Center of gravity

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  24 > MAXPOINTS) or
      (wNumFaces  + 14 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // Size of an edge, in [cm]
   vRadiusL:=4.0; // [cm]
   vSizeL  :=(1/sqrt(3)) * vRadiusL;

   // If the TruncatedCube exist already, modify it, but do not create another one !
   if (wBodySelected > 0) and
      (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11031)) then begin
     fNewCreation:=False;
     parPtsL:=@parPoints^[papoBodies^[wBodySelected]^.wIndPtsMin];

     //  to have exactly a truncated cube
     vC:=sqrt(2) - 1 + papoBodies^[wBodySelected]^.lUserData / 100;

     // center of gravity of the object
     vecGC:=papoBodies^[wBodySelected]^.vecGravityCenter;

     // Actual orientation of the body is memorized, the set to its default value,
     // to rotate the body to the right value again after redefinition of its vertices.
     vecBodyVertZ_old:=papoBodies^[wBodySelected]^.vecBodyVertZ;
     papoBodies^[wBodySelected]^.vecBodyVertZ:=V3Assign(0,0,1);
     vecBodyHorizX_old:=papoBodies^[wBodySelected]^.vecBodyHorizX;
     papoBodies^[wBodySelected]^.vecBodyHorizX:=V3Assign(1,0,0);
     papoBodies^[wBodySelected]^.vecBodyFrontY :=V3Assign(0,1,0);
     end
   else begin
     // Creates a new body
     fNewCreation:=True;
     inc(wNumBodies);
     new(papoBodies^[wNumBodies], Init(poDraw3D));
     parPtsL:=@parPoints^[wNumPoints+1];

     // to modify the truncated cube
     papoBodies^[wNumBodies]^.lUserData :=0;

     //  to have exactly a truncated cube
     vC:=sqrt(2) - 1;

     // center of gravity of the object
     vecGC:=papoBodies^[wNumBodies]^.vecGravityCenter;
     end;

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vecGC + vSizeL * V3Assign( -1, -1, vC); //  0
   parPtsL^[ 1].vecV:=vecGC + vSizeL * V3Assign( -1, -1,-vC); //  1
   parPtsL^[ 2].vecV:=vecGC + vSizeL * V3Assign( -1,-vC, -1); //  2
   parPtsL^[ 3].vecV:=vecGC + vSizeL * V3Assign( -1, vC, -1); //  3
   parPtsL^[ 4].vecV:=vecGC + vSizeL * V3Assign( -1,  1,-vC); //  4
   parPtsL^[ 5].vecV:=vecGC + vSizeL * V3Assign( -1,  1, vC); //  5
   parPtsL^[ 6].vecV:=vecGC + vSizeL * V3Assign( -1, vC,  1); //  6
   parPtsL^[ 7].vecV:=vecGC + vSizeL * V3Assign( -1,-vC,  1); //  7

   parPtsL^[ 8].vecV:=vecGC + vSizeL * V3Assign(-vC,  1,  1); //  8
   parPtsL^[ 9].vecV:=vecGC + vSizeL * V3Assign( vC,  1,  1); //  9
   parPtsL^[10].vecV:=vecGC + vSizeL * V3Assign(  1,  1, vC); // 10
   parPtsL^[11].vecV:=vecGC + vSizeL * V3Assign(  1,  1,-vC); // 11
   parPtsL^[12].vecV:=vecGC + vSizeL * V3Assign( vC,  1, -1); // 12
   parPtsL^[13].vecV:=vecGC + vSizeL * V3Assign(-vC,  1, -1); // 13

   parPtsL^[14].vecV:=vecGC + vSizeL * V3Assign(  1, vC,  1); // 14
   parPtsL^[15].vecV:=vecGC + vSizeL * V3Assign(  1,-vC,  1); // 15
   parPtsL^[16].vecV:=vecGC + vSizeL * V3Assign(  1, -1, vC); // 16
   parPtsL^[17].vecV:=vecGC + vSizeL * V3Assign(  1, -1,-vC); // 17
   parPtsL^[18].vecV:=vecGC + vSizeL * V3Assign(  1,-vC, -1); // 18
   parPtsL^[19].vecV:=vecGC + vSizeL * V3Assign(  1, vC, -1); // 19

   parPtsL^[20].vecV:=vecGC + vSizeL * V3Assign( vC, -1, -1); // 20
   parPtsL^[21].vecV:=vecGC + vSizeL * V3Assign(-vC, -1, -1); // 21
   parPtsL^[22].vecV:=vecGC + vSizeL * V3Assign(-vC, -1,  1); // 22
   parPtsL^[23].vecV:=vecGC + vSizeL * V3Assign( vC, -1,  1); // 23

  if (fNewCreation) then begin
   // if it is not only a modification, create the body...
   wNumPoints:=wNumPoints + 24;

   poDraw3D^.AddNewFace(parPtsL,  0,  1,  2,  3,  4,  5,  6,  7);
   poDraw3D^.AddNewFace(parPtsL,  4,  5,  8,  9, 10, 11, 12, 13);
   poDraw3D^.AddNewFace(parPtsL, 11, 10, 14, 15, 16, 17, 18, 19);
   poDraw3D^.AddNewFace(parPtsL,  0, 22, 23, 16, 17, 20, 21,  1);
   poDraw3D^.AddNewFace(parPtsL,  6,  7, 22, 23, 15, 14,  9,  8);
   poDraw3D^.AddNewFace(parPtsL,  3,  2, 21, 20, 18, 19, 12, 13);

   poDraw3D^.AddNewFace(parPtsL,  5,  6,  8);
   poDraw3D^.AddNewFace(parPtsL,  9, 10, 14);
   poDraw3D^.AddNewFace(parPtsL, 15, 16, 23);
   poDraw3D^.AddNewFace(parPtsL,  0,  7, 22);
   poDraw3D^.AddNewFace(parPtsL,  3,  4, 13);
   poDraw3D^.AddNewFace(parPtsL, 11, 12, 19);
   poDraw3D^.AddNewFace(parPtsL, 17, 18, 20);
   poDraw3D^.AddNewFace(parPtsL,  1,  2, 21);

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11031); // A truncated Cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

  end // if (fNewCreation) then begin
  else begin
    // Body existed already, set its orientation.
    papoBodies^[wBodySelected]^.BodySetOrientation(vecBodyVertZ_old, vecBodyHorizX_old);
    end;

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.TruncatedCubeFull

procedure TMyWindow.TruncatedCubeEdges;
//=====================================
// Edges of a Truncated cube !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  vC          : Float; // for the coordinate of the vertices.
  fNewCreation : boolean;  // true if a new Truncated cube is created
  vecBodyVertZ_old,  //  actual body orientation
  vecBodyHorizX_old,
  vecGC        : RVectR3Float;  // Center of gravity
  poBodyEdgeCreator : PBody3DEdgesCreator;

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  1023 > MAXPOINTS) or
      (wNumFaces  + 1014 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // If the TruncatedCube exist already, modify it, but do not create another one !
   if (wBodySelected > 0) and
      (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11131)) then begin
     fNewCreation:=False;

     //  to have exactly a truncated cube
     vC:=sqrt(2) - 1 + papoBodies^[wBodySelected]^.lUserData / 100;

     // center of gravity of the object
     vecGC:=papoBodies^[wBodySelected]^.vecGravityCenter;

     // Actual orientation of the body is memorized, the set to its default value,
     // to rotate the body to the right value again after redefinition of its vertices.
     vecBodyVertZ_old:=papoBodies^[wBodySelected]^.vecBodyVertZ;
     papoBodies^[wBodySelected]^.vecBodyVertZ:=V3Assign(0,0,1);
     vecBodyHorizX_old:=papoBodies^[wBodySelected]^.vecBodyHorizX;
     papoBodies^[wBodySelected]^.vecBodyHorizX:=V3Assign(1,0,0);
     papoBodies^[wBodySelected]^.vecBodyFrontY :=V3Assign(0,1,0);
     end
   else begin
     // Creates a new body
     fNewCreation:=True;
     inc(wNumBodies);
     new(papoBodies^[wNumBodies], Init(poDraw3D));

     // to modify the truncated cube
     papoBodies^[wNumBodies]^.lUserData :=0;

     //  to have exactly a truncated cube
     vC:=sqrt(2) - 1;

     // center of gravity of the object
     vecGC:=papoBodies^[wNumBodies]^.vecGravityCenter;
     end;

   // Size of an edge, in [cm]
   vRadiusL:=4.0; // [cm]
   vSizeL  :=vRadiusL;

   parPtsL:=@parPoints^[wNumPoints+1000];

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vecGC + vSizeL * V3Assign( -1, -1, vC); //  0
   parPtsL^[ 1].vecV:=vecGC + vSizeL * V3Assign( -1, -1,-vC); //  1
   parPtsL^[ 2].vecV:=vecGC + vSizeL * V3Assign( -1,-vC, -1); //  2
   parPtsL^[ 3].vecV:=vecGC + vSizeL * V3Assign( -1, vC, -1); //  3
   parPtsL^[ 4].vecV:=vecGC + vSizeL * V3Assign( -1,  1,-vC); //  4
   parPtsL^[ 5].vecV:=vecGC + vSizeL * V3Assign( -1,  1, vC); //  5
   parPtsL^[ 6].vecV:=vecGC + vSizeL * V3Assign( -1, vC,  1); //  6
   parPtsL^[ 7].vecV:=vecGC + vSizeL * V3Assign( -1,-vC,  1); //  7

   parPtsL^[ 8].vecV:=vecGC + vSizeL * V3Assign(-vC,  1,  1); //  8
   parPtsL^[ 9].vecV:=vecGC + vSizeL * V3Assign( vC,  1,  1); //  9
   parPtsL^[10].vecV:=vecGC + vSizeL * V3Assign(  1,  1, vC); // 10
   parPtsL^[11].vecV:=vecGC + vSizeL * V3Assign(  1,  1,-vC); // 11
   parPtsL^[12].vecV:=vecGC + vSizeL * V3Assign( vC,  1, -1); // 12
   parPtsL^[13].vecV:=vecGC + vSizeL * V3Assign(-vC,  1, -1); // 13

   parPtsL^[14].vecV:=vecGC + vSizeL * V3Assign(  1, vC,  1); // 14
   parPtsL^[15].vecV:=vecGC + vSizeL * V3Assign(  1,-vC,  1); // 15
   parPtsL^[16].vecV:=vecGC + vSizeL * V3Assign(  1, -1, vC); // 16
   parPtsL^[17].vecV:=vecGC + vSizeL * V3Assign(  1, -1,-vC); // 17
   parPtsL^[18].vecV:=vecGC + vSizeL * V3Assign(  1,-vC, -1); // 18
   parPtsL^[19].vecV:=vecGC + vSizeL * V3Assign(  1, vC, -1); // 19

   parPtsL^[20].vecV:=vecGC + vSizeL * V3Assign( vC, -1, -1); // 20
   parPtsL^[21].vecV:=vecGC + vSizeL * V3Assign(-vC, -1, -1); // 21
   parPtsL^[22].vecV:=vecGC + vSizeL * V3Assign(-vC, -1,  1); // 22
   parPtsL^[23].vecV:=vecGC + vSizeL * V3Assign( vC, -1,  1); // 23

   wNumFaces:=wNumFaces + 1000;
   poDraw3D^.AddNewFace(parPtsL,  0,  1,  2,  3,  4,  5,  6,  7);
   poDraw3D^.AddNewFace(parPtsL,  4,  5,  8,  9, 10, 11, 12, 13);
   poDraw3D^.AddNewFace(parPtsL, 11, 10, 14, 15, 16, 17, 18, 19);
   poDraw3D^.AddNewFace(parPtsL,  0, 22, 23, 16, 17, 20, 21,  1);
   poDraw3D^.AddNewFace(parPtsL,  6,  7, 22, 23, 15, 14,  9,  8);
   poDraw3D^.AddNewFace(parPtsL,  3,  2, 21, 20, 18, 19, 12, 13);

   poDraw3D^.AddNewFace(parPtsL,  5,  6,  8);
   poDraw3D^.AddNewFace(parPtsL,  9, 10, 14);
   poDraw3D^.AddNewFace(parPtsL, 15, 16, 23);
   poDraw3D^.AddNewFace(parPtsL,  0,  7, 22);
   poDraw3D^.AddNewFace(parPtsL,  3,  4, 13);
   poDraw3D^.AddNewFace(parPtsL, 11, 12, 19);
   poDraw3D^.AddNewFace(parPtsL, 17, 18, 20);
   poDraw3D^.AddNewFace(parPtsL,  1,  2, 21);

   wNumFaces:=wNumFaces - 1014;

   // Creates a new body...
   new(poBodyEdgeCreator, init(poDraw3D));
   // given data :
   //=============
   with poBodyEdgeCreator^ do begin
     parPointsIn  :=parPtsL;
     wNumPointsIn :=24;
     parFacesIn   :=@parFaces^[wNumFaces+1001];
     wNumFacesIn  :=14;

     if (fNewCreation) then parPointsOut:=@parPoints^[wNumPoints]
     else                   parPointsOut:=@parPoints^[papoBodies^[wBodySelected]^.wIndPtsMin-1];

     parFacesOut  :=@parFaces^[wNumFaces];
     wMaxPointsOut:=900;
     wMaxFacesOut :=900;

     if (fNewCreation) then begin
       CreateFacesFromBody(0);

       wNumPoints   :=wNumPoints + wNumPointsOut;
       wNumFaces    :=wNumFaces + wNumFacesOut;
       end
     else CreateFacesFromBody(1);

     end; // with


  if (fNewCreation) then begin
   //-----------------------------------------------------------
   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11131); // A truncated Cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

  end // if (fNewCreation) then begin
  else begin
    // Body existed already, set its orientation.
    papoBodies^[wBodySelected]^.BodySetOrientation(vecBodyVertZ_old, vecBodyHorizX_old);
    end;

  // Erase the background and draw the Body
  Draw3DBodies;
  end; // with
end;  // TMyWindow.TruncatedCubeEdges

procedure TMyWindow.TruncatedTetrahedronFull;
//===========================================
// Faces of a Truncated tetrahedron !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  vC          : Float; // for the coordinate of the vertices.
  fNewCreation : boolean;  // true if a new Truncated tetrahedron is created
  a,b,c,d,e,f,g,h,i,j,k,l, // coordinates to compute the vertices.
  vecBodyVertZ_old,  //  actual body orientation
  vecBodyHorizX_old,
  vecGC        : RVectR3Float;  // Center of gravity

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  12 > MAXPOINTS) or
      (wNumFaces  + 8 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // Size of an edge, in [cm]
   vRadiusL:=3.0; // [cm]
   vSizeL  :=(1/sqrt(8)) * vRadiusL;

   // If the Truncated tetrahedron exist already, modify it, but do not create another one !
   if (wBodySelected > 0) and
      (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11032)) then begin
     fNewCreation:=False;
     parPtsL:=@parPoints^[papoBodies^[wBodySelected]^.wIndPtsMin];

     //  to have exactly a truncated cube
     vC:=papoBodies^[wBodySelected]^.lUserData / 100;

     // center of gravity of the object
     vecGC:=papoBodies^[wBodySelected]^.vecGravityCenter;

     // Actual orientation of the body is memorized, the set to its default value,
     // to rotate the body to the right value again after redefinition of its vertices.
     vecBodyVertZ_old:=papoBodies^[wBodySelected]^.vecBodyVertZ;
     papoBodies^[wBodySelected]^.vecBodyVertZ:=V3Assign(0,0,1);
     vecBodyHorizX_old:=papoBodies^[wBodySelected]^.vecBodyHorizX;
     papoBodies^[wBodySelected]^.vecBodyHorizX:=V3Assign(1,0,0);
     papoBodies^[wBodySelected]^.vecBodyFrontY :=V3Assign(0,1,0);
     end
   else begin
     // Creates a new body
     fNewCreation:=True;
     inc(wNumBodies);
     new(papoBodies^[wNumBodies], Init(poDraw3D));
     parPtsL:=@parPoints^[wNumPoints+1];

     // to modify the truncated cube
     papoBodies^[wNumBodies]^.lUserData :=0;

     //  to have exactly a truncated cube
     vC:=0;

     // center of gravity of the object
     vecGC:=papoBodies^[wNumBodies]^.vecGravityCenter;
     end;

   // to compute the vertices.
   a:=vSizeL * V3Assign(  3,  1,  1); //  0
   b:=vSizeL * V3Assign(  1,  3,  1); //  1
   c:=vSizeL * V3Assign(  1,  1,  3); //  2
   d:=vSizeL * V3Assign( -3, -1,  1); //  3
   e:=vSizeL * V3Assign( -1, -3,  1); //  4
   f:=vSizeL * V3Assign( -1, -1,  3); //  5
   g:=vSizeL * V3Assign( -3,  1, -1); //  6
   h:=vSizeL * V3Assign( -1,  3, -1); //  7
   i:=vSizeL * V3Assign( -1,  1, -3); //  8
   j:=vSizeL * V3Assign(  3, -1, -1); //  9
   k:=vSizeL * V3Assign(  1, -3, -1); // 10
   l:=vSizeL * V3Assign(  1, -1, -3); // 11

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vecGC + a + vC * (a - j);
   parPtsL^[ 1].vecV:=vecGC + b + vC * (b - h);
   parPtsL^[ 2].vecV:=vecGC + c + vC * (c - f);

   parPtsL^[ 3].vecV:=vecGC + d + vC * (d - g);
   parPtsL^[ 4].vecV:=vecGC + e + vC * (e - k);
   parPtsL^[ 5].vecV:=vecGC + f + vC * (f - c);

   parPtsL^[ 6].vecV:=vecGC + g + vC * (g - d);
   parPtsL^[ 7].vecV:=vecGC + h + vC * (h - b);
   parPtsL^[ 8].vecV:=vecGC + i + vC * (i - l);

   parPtsL^[ 9].vecV:=vecGC + j + vC * (j - a);
   parPtsL^[10].vecV:=vecGC + k + vC * (k - e);
   parPtsL^[11].vecV:=vecGC + l + vC * (l - i);

  if (fNewCreation) then begin
   // if it is not only a modification, create the body...
   wNumPoints:=wNumPoints + 12;

   // Add the "faces"
   poDraw3D^.AddNewFace(parPtsL,  0,  1,  7,  8, 11, 9);
   poDraw3D^.AddNewFace(parPtsL,  1,  2,  5,  3,  6, 7);
   poDraw3D^.AddNewFace(parPtsL,  3,  4, 10, 11, 8,  6);
   poDraw3D^.AddNewFace(parPtsL,  0,  2,  5,  4, 10,  9);
   poDraw3D^.AddNewFace(parPtsL,  0,  1,  2);
   poDraw3D^.AddNewFace(parPtsL,  6,  7,  8);
   poDraw3D^.AddNewFace(parPtsL,  9, 10, 11);
   poDraw3D^.AddNewFace(parPtsL,  3,  4,  5);

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11032); // A truncated tetrahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

  end // if (fNewCreation) then begin
  else begin
    // Body existed already, set its orientation.
    papoBodies^[wBodySelected]^.BodySetOrientation(vecBodyVertZ_old, vecBodyHorizX_old);
    end;

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.TruncatedTetrahedronFull

procedure TMyWindow.TruncatedOctahedronFull;
//===========================================
// Faces of a Truncated octahedron !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  vC          : Float; // for the coordinate of the vertices.
  fNewCreation : boolean;  // true if a new Truncated octahedron is created
  z00,z01,z02,z03,z04,z05,z06,z07,z08,z09,z10,z11,
  z12,z13,z14,z15,z16,z17,z18,z19,z20,z21,z22,z23, // coordinates to compute the vertices.
  vecBodyVertZ_old,  //  actual body orientation
  vecBodyHorizX_old,
  vecGC        : RVectR3Float;  // Center of gravity

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  24 > MAXPOINTS) or
      (wNumFaces  + 14 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // Size of an edge, in [cm]
   vRadiusL:=3.0; // [cm]
   vSizeL  :=(1/2) * vRadiusL;

   // If the Truncated tetrahedron exist already, modify it, but do not create another one !
   if (wBodySelected > 0) and
      (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11033)) then begin
     fNewCreation:=False;
     parPtsL:=@parPoints^[papoBodies^[wBodySelected]^.wIndPtsMin];

     //  to have exactly a truncated cube
     vC:=papoBodies^[wBodySelected]^.lUserData / 100;

     // center of gravity of the object
     vecGC:=papoBodies^[wBodySelected]^.vecGravityCenter;

     // Actual orientation of the body is memorized, the set to its default value,
     // to rotate the body to the right value again after redefinition of its vertices.
     vecBodyVertZ_old:=papoBodies^[wBodySelected]^.vecBodyVertZ;
     papoBodies^[wBodySelected]^.vecBodyVertZ:=V3Assign(0,0,1);
     vecBodyHorizX_old:=papoBodies^[wBodySelected]^.vecBodyHorizX;
     papoBodies^[wBodySelected]^.vecBodyHorizX:=V3Assign(1,0,0);
     papoBodies^[wBodySelected]^.vecBodyFrontY :=V3Assign(0,1,0);
     end
   else begin
     // Creates a new body
     fNewCreation:=True;
     inc(wNumBodies);
     new(papoBodies^[wNumBodies], Init(poDraw3D));
     parPtsL:=@parPoints^[wNumPoints+1];

     // to modify the truncated cube
     papoBodies^[wNumBodies]^.lUserData :=0;

     //  to have exactly a truncated cube
     vC:=0;

     // center of gravity of the object
     vecGC:=papoBodies^[wNumBodies]^.vecGravityCenter;
     end;

   // to compute the vertices.
   z00:=vSizeL * V3Assign( 0, 1, 2); //  0
   z01:=vSizeL * V3Assign(-1, 0, 2); //  1
   z02:=vSizeL * V3Assign( 0,-1, 2); //  2
   z03:=vSizeL * V3Assign( 1, 0, 2); //  3

   z04:=vSizeL * V3Assign(-2, 0, 1); //  4
   z05:=vSizeL * V3Assign(-2, 1, 0); //  5
   z06:=vSizeL * V3Assign(-2, 0,-1); //  6
   z07:=vSizeL * V3Assign(-2,-1, 0); //  7

   z08:=vSizeL * V3Assign( 0,-2, 1); //  8
   z09:=vSizeL * V3Assign(-1,-2, 0); //  9
   z10:=vSizeL * V3Assign( 0,-2,-1); // 10
   z11:=vSizeL * V3Assign( 1,-2, 0); // 11

   z12:=vSizeL * V3Assign( 0, 1,-2); // 12
   z13:=vSizeL * V3Assign(-1, 0,-2); // 13
   z14:=vSizeL * V3Assign( 0,-1,-2); // 14
   z15:=vSizeL * V3Assign( 1, 0,-2); // 15

   z16:=vSizeL * V3Assign( 2, 0, 1); // 16
   z17:=vSizeL * V3Assign( 2, 1, 0); // 17
   z18:=vSizeL * V3Assign( 2, 0,-1); // 18
   z19:=vSizeL * V3Assign( 2,-1, 0); // 19

   z20:=vSizeL * V3Assign( 0, 2, 1); // 20
   z21:=vSizeL * V3Assign(-1, 2, 0); // 21
   z22:=vSizeL * V3Assign( 0, 2,-1); // 22
   z23:=vSizeL * V3Assign( 1, 2, 0); // 23

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vecGC + z00 + vC * (z00 - z20);
   parPtsL^[ 1].vecV:=vecGC + z01 + vC * (z01 - z04);
   parPtsL^[ 2].vecV:=vecGC + z02 + vC * (z02 - z08);
   parPtsL^[ 3].vecV:=vecGC + z03 + vC * (z03 - z16);

   parPtsL^[ 4].vecV:=vecGC + z04 + vC * (z04 - z01);
   parPtsL^[ 5].vecV:=vecGC + z05 + vC * (z05 - z21);
   parPtsL^[ 6].vecV:=vecGC + z06 + vC * (z06 - z13);
   parPtsL^[ 7].vecV:=vecGC + z07 + vC * (z07 - z09);

   parPtsL^[ 8].vecV:=vecGC + z08 + vC * (z08 - z02);
   parPtsL^[ 9].vecV:=vecGC + z09 + vC * (z09 - z07);
   parPtsL^[10].vecV:=vecGC + z10 + vC * (z10 - z14);
   parPtsL^[11].vecV:=vecGC + z11 + vC * (z11 - z19);

   parPtsL^[12].vecV:=vecGC + z12 + vC * (z12 - z22);
   parPtsL^[13].vecV:=vecGC + z13 + vC * (z13 - z06);
   parPtsL^[14].vecV:=vecGC + z14 + vC * (z14 - z10);
   parPtsL^[15].vecV:=vecGC + z15 + vC * (z15 - z18);

   parPtsL^[16].vecV:=vecGC + z16 + vC * (z16 - z03);
   parPtsL^[17].vecV:=vecGC + z17 + vC * (z17 - z23);
   parPtsL^[18].vecV:=vecGC + z18 + vC * (z18 - z15);
   parPtsL^[19].vecV:=vecGC + z19 + vC * (z19 - z11);

   parPtsL^[20].vecV:=vecGC + z20 + vC * (z20 - z00);
   parPtsL^[21].vecV:=vecGC + z21 + vC * (z21 - z05);
   parPtsL^[22].vecV:=vecGC + z22 + vC * (z22 - z12);
   parPtsL^[23].vecV:=vecGC + z23 + vC * (z23 - z17);

  if (fNewCreation) then begin
   // if it is not only a modification, create the body...
   wNumPoints:=wNumPoints + 24;

   // Add the 14 "faces".
//   poDraw3D^.AddNewFace(parPtsL, , , , , , , , );
   poDraw3D^.AddNewFace(parPtsL,  1,  4,  7,  9,  8,  2);
   poDraw3D^.AddNewFace(parPtsL,  1,  4,  5, 21, 20,  0);
   poDraw3D^.AddNewFace(parPtsL,  7,  6, 13, 14, 10,  9);
   poDraw3D^.AddNewFace(parPtsL,  0, 20, 23, 17, 16,  3);
   poDraw3D^.AddNewFace(parPtsL,  5,  6, 13, 12, 22, 21);
   poDraw3D^.AddNewFace(parPtsL, 12, 15, 18, 17, 23, 22);
   poDraw3D^.AddNewFace(parPtsL,  3,  2,  8, 11, 19, 16);
   poDraw3D^.AddNewFace(parPtsL, 10, 14, 15, 18, 19, 11);

   poDraw3D^.AddNewFace(parPtsL,  0,  1,  2,  3);
   poDraw3D^.AddNewFace(parPtsL,  4,  5,  6,  7);
   poDraw3D^.AddNewFace(parPtsL,  8,  9, 10, 11);
   poDraw3D^.AddNewFace(parPtsL, 12, 13, 14, 15);
   poDraw3D^.AddNewFace(parPtsL, 16, 17, 18, 19);
   poDraw3D^.AddNewFace(parPtsL, 20, 21, 22, 23);

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11033); // A truncated octahedron

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

  end // if (fNewCreation) then begin
  else begin
    // Body existed already, set its orientation.
    papoBodies^[wBodySelected]^.BodySetOrientation(vecBodyVertZ_old, vecBodyHorizX_old);
    end;

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.TruncatedOctahedronFull

procedure TMyWindow.SnubCubeFull;
//===============================
// Faces of a SnubCubeFull !
var
  parPtsL     : PArrayPoint3D;
  vSizeL,
  vRadiusL    : Float; // Radius of the sphere containing the cube
  vA,
  vC          : Float; // for the coordinate of the vertices.
  fNewCreation : boolean;  // true if a new body is created
  vecBodyVertZ_old,  //  actual body orientation
  vecBodyHorizX_old,
  vecGC        : RVectR3Float;  // Center of gravity

begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints +  24 > MAXPOINTS) or
      (wNumFaces  + 38 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // Size of an edge, in [cm]
   vRadiusL:=3.0; // [cm]
   vSizeL  :=(1/2) * vRadiusL;

   // If the body exist already, modify it, but do not create another one !
   if (wBodySelected > 0) and
      (papoBodies^[wBodySelected]^.strBodyName = GetMsg(11034)) then begin
     fNewCreation:=False;
     parPtsL:=@parPoints^[papoBodies^[wBodySelected]^.wIndPtsMin];

     //  to have exactly a snub cube
     vC:=0.543689 + papoBodies^[wBodySelected]^.lUserData / 100;
     vA:=1 / vC;

     // center of gravity of the object
     vecGC:=papoBodies^[wBodySelected]^.vecGravityCenter;

     // Actual orientation of the body is memorized, the set to its default value,
     // to rotate the body to the right value again after redefinition of its vertices.
     vecBodyVertZ_old:=papoBodies^[wBodySelected]^.vecBodyVertZ;
     papoBodies^[wBodySelected]^.vecBodyVertZ:=V3Assign(0,0,1);
     vecBodyHorizX_old:=papoBodies^[wBodySelected]^.vecBodyHorizX;
     papoBodies^[wBodySelected]^.vecBodyHorizX:=V3Assign(1,0,0);
     papoBodies^[wBodySelected]^.vecBodyFrontY :=V3Assign(0,1,0);
     end
   else begin
     // Creates a new body
     fNewCreation:=True;
     inc(wNumBodies);
     new(papoBodies^[wNumBodies], Init(poDraw3D));
     parPtsL:=@parPoints^[wNumPoints+1];

     // to modify the truncated cube
     papoBodies^[wNumBodies]^.lUserData :=0;

     //  to have exactly a snub Cube
     vC:=0.543689;
     vA:=1 / vC;

     // center of gravity of the object
     vecGC:=papoBodies^[wNumBodies]^.vecGravityCenter;
     end;

   // Add the points. Units = cm
   parPtsL^[ 0].vecV:=vecGC + vSizeL * V3Assign( vC,  1, vA); //  0
   parPtsL^[ 1].vecV:=vecGC + vSizeL * V3Assign( -1, vC, vA); //  1
   parPtsL^[ 2].vecV:=vecGC + vSizeL * V3Assign(-vC, -1, vA); //  2
   parPtsL^[ 3].vecV:=vecGC + vSizeL * V3Assign(  1,-vC, vA); //  3
   parPtsL^[ 4].vecV:=vecGC + vSizeL * V3Assign(  1, vA, vC); //  4
   parPtsL^[ 5].vecV:=vecGC + vSizeL * V3Assign(-vC, vA,  1); //  5

   parPtsL^[ 6].vecV:=vecGC + vSizeL * V3Assign(-vA,  1, vC); //  6
   parPtsL^[ 7].vecV:=vecGC + vSizeL * V3Assign(-vA,-vC,  1); //  7
   parPtsL^[ 8].vecV:=vecGC + vSizeL * V3Assign( -1,-vA, vC); //  8
   parPtsL^[ 9].vecV:=vecGC + vSizeL * V3Assign( vC,-vA,  1); //  9
   parPtsL^[10].vecV:=vecGC + vSizeL * V3Assign( vA, -1, vC); // 10
   parPtsL^[11].vecV:=vecGC + vSizeL * V3Assign( vA, vC,  1); // 11

   parPtsL^[12].vecV:=vecGC + vSizeL * V3Assign(  1, vC,-vA); // 12
   parPtsL^[13].vecV:=vecGC + vSizeL * V3Assign( vC, -1,-vA); // 13
   parPtsL^[14].vecV:=vecGC + vSizeL * V3Assign( -1,-vC,-vA); // 14
   parPtsL^[15].vecV:=vecGC + vSizeL * V3Assign(-vC,  1,-vA); // 15
   parPtsL^[16].vecV:=vecGC + vSizeL * V3Assign( vA,  1,-vC); // 16
   parPtsL^[17].vecV:=vecGC + vSizeL * V3Assign( vA,-vC, -1); // 17

   parPtsL^[18].vecV:=vecGC + vSizeL * V3Assign(  1,-vA,-vC); // 18
   parPtsL^[19].vecV:=vecGC + vSizeL * V3Assign(-vC,-vA, -1); // 19
   parPtsL^[20].vecV:=vecGC + vSizeL * V3Assign(-vA, -1,-vC); // 20
   parPtsL^[21].vecV:=vecGC + vSizeL * V3Assign(-vA, vC, -1); // 21
   parPtsL^[22].vecV:=vecGC + vSizeL * V3Assign( -1, vA,-vC); // 22
   parPtsL^[23].vecV:=vecGC + vSizeL * V3Assign( vC, vA, -1); // 23

  if (fNewCreation) then begin
   // if it is not only a modification, create the body...
   wNumPoints:=wNumPoints + 24;

   // Add the 38 "faces".
//   poDraw3D^.AddNewFace(parPtsL, , , , , , , , );
   poDraw3D^.AddNewFace(parPtsL,  0,  1,  2,  3);
   poDraw3D^.AddNewFace(parPtsL,  0, 11,  4);
   poDraw3D^.AddNewFace(parPtsL,  0,  4,  5);
   poDraw3D^.AddNewFace(parPtsL,  0,  5,  1);
   poDraw3D^.AddNewFace(parPtsL,  1,  5,  6);
   poDraw3D^.AddNewFace(parPtsL,  1,  6,  7);
   poDraw3D^.AddNewFace(parPtsL,  1,  7,  2);
   poDraw3D^.AddNewFace(parPtsL,  2,  7,  8);
   poDraw3D^.AddNewFace(parPtsL,  2,  8,  9);
   poDraw3D^.AddNewFace(parPtsL,  2,  9,  3);
   poDraw3D^.AddNewFace(parPtsL,  3,  9, 10);
   poDraw3D^.AddNewFace(parPtsL,  3, 10, 11);  // 12
   poDraw3D^.AddNewFace(parPtsL,  3, 11,  0);  // 13

   poDraw3D^.AddNewFace(parPtsL, 12, 13, 14, 15);
   poDraw3D^.AddNewFace(parPtsL, 12, 23, 16);
   poDraw3D^.AddNewFace(parPtsL, 12, 16, 17);
   poDraw3D^.AddNewFace(parPtsL, 12, 17, 13);
   poDraw3D^.AddNewFace(parPtsL, 13, 17, 18);
   poDraw3D^.AddNewFace(parPtsL, 13, 18, 19);
   poDraw3D^.AddNewFace(parPtsL, 13, 19, 14);
   poDraw3D^.AddNewFace(parPtsL, 14, 19, 20);
   poDraw3D^.AddNewFace(parPtsL, 14, 20, 21);
   poDraw3D^.AddNewFace(parPtsL, 14, 21, 15);
   poDraw3D^.AddNewFace(parPtsL, 15, 21, 22);
   poDraw3D^.AddNewFace(parPtsL, 15, 22, 23);
   poDraw3D^.AddNewFace(parPtsL, 15, 23, 12);  // 26

   poDraw3D^.AddNewFace(parPtsL,  7,  6, 21, 20);
   poDraw3D^.AddNewFace(parPtsL,  9,  8, 19, 18);
   poDraw3D^.AddNewFace(parPtsL, 11, 10, 17, 16);
   poDraw3D^.AddNewFace(parPtsL,  5,  4, 23, 22); // 30

   poDraw3D^.AddNewFace(parPtsL,  8,  7, 20); // 31
   poDraw3D^.AddNewFace(parPtsL,  8, 20, 19);
   poDraw3D^.AddNewFace(parPtsL, 10,  9, 18);
   poDraw3D^.AddNewFace(parPtsL, 10, 18, 17);
   poDraw3D^.AddNewFace(parPtsL,  4, 11, 16);
   poDraw3D^.AddNewFace(parPtsL,  4, 16, 23);
   poDraw3D^.AddNewFace(parPtsL,  6,  5, 22);
   poDraw3D^.AddNewFace(parPtsL,  6, 22, 21);  // 38

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=TRUE; // Ask to have a unique color
//   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,128);
//   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,255,128);
   papoBodies^[wNumBodies]^.colorAx.wColor:=RGB(128,255,255);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11034); // A snub cube

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

  end // if (fNewCreation) then begin
  else begin
    // Body existed already, set its orientation.
    papoBodies^[wBodySelected]^.BodySetOrientation(vecBodyVertZ_old, vecBodyHorizX_old);
    end;

   // Erase the background and draw the Body
   Draw3DBodies;
   end; // with
end;  // TMyWindow.SnubCubeFull

procedure TMyWindow.TestZ;
//========================
// To test special cases
begin
with poDraw3D^ do begin
   // Test that there is enough space to add a Body
   if (wNumPoints + 20 > MAXPOINTS) or
      (wNumFaces  +  4 > MAXFACES) then begin
      DialogExecMSG(12099, @Self);
      exit;
      end;

   // Creates a new body
   inc(wNumBodies);
   new(papoBodies^[wNumBodies], Init(poDraw3D));

   // Add points and faces, for particual tests. Units = cm
   inc(wNumFaces);
   inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=V3Assign(0.00, 0.00,0.00);
   parFaces^[wNumFaces].aprPoint[1]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(0.50,-0.50,0.50);
   parFaces^[wNumFaces].aprPoint[2]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(1.00, 0.00,0.00);
   parFaces^[wNumFaces].aprPoint[3]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(0.50, 0.50,0.50);
   parFaces^[wNumFaces].aprPoint[4]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parFaces^[wNumFaces].nNbPoint:=4;

   // Add two faces, to see that proglems can occure with only two
   // faces, if we want to distinguish the top from the bottom of the faces
   // For some point of view,
   // The edge (2.50, 0.10, 0.00) --- (2.50, 0.00, 0.00)
   // should be both colors since it belongs to a face which upper face is
   // visible and to a face which lower face is visible.
   inc(wNumFaces);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.00, 0.00, 0.00);
   parFaces^[wNumFaces].aprPoint[1]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.50, 0.30, 0.00);
   parFaces^[wNumFaces].aprPoint[2]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.50, 0.30, 1.00);
   parFaces^[wNumFaces].aprPoint[3]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.00, 0.00, 1.00);
   parFaces^[wNumFaces].aprPoint[4]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parFaces^[wNumFaces].nNbPoint:=4;

   inc(wNumFaces);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.50, 0.30, 0.00);
   parFaces^[wNumFaces].aprPoint[1]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(3.00, 0.00, 0.00);
   parFaces^[wNumFaces].aprPoint[2]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(3.00, 0.00, 1.00);
   parFaces^[wNumFaces].aprPoint[3]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parPoints^[wNumPoints].vecV:=5.0*V3Assign(2.50, 0.30, 1.00);
   parFaces^[wNumFaces].aprPoint[4]:=@parPoints^[wNumPoints]; inc(wNumPoints);
   parFaces^[wNumFaces].nNbPoint:=4;

   dec(wNumPoints);

   // Optional, defining if one or two colors are used, and
   // can change the default standard colors
   // The Created Pen will be destroyed automatically
   papoBodies^[wNumBodies]^.fUniColor:=FALSE; // Ask to have two colors
   papoBodies^[wNumBodies]^.colorSup.wColor:=RGB(255,255,255);
   papoBodies^[wNumBodies]^.colorInf.wColor:=RGB(255,  0,  0);
   papoBodies^[wNumBodies]^.strBodyName:=GetMsg(11101); // A Problem

   // Some final setups, positionning and Drawing
   FinalBodySetup;

   // Final rotation for the viweing
//   papoBodies^[wNumBodies]^.BodyRotateGC(vecRight, 35*Pi/180);

   // Erase the background and draw the problem figure
   Draw3DBodies;
   end; // with
end;  // TMyWindow.TestZ

procedure TMyWindow.ToggleView3D(fRedrawP:boolean);
//================================================
// Change the 3D viewing, with glasses or without glasses
begin
poDraw3D^.fView3DWithGalsses:=not poDraw3D^.fView3DWithGalsses;

if poDraw3D^.fView3DWithGalsses then
     CheckMenuItem(hMenuWin, 121, MF_BYCOMMAND or MF_CHECKED)
else CheckMenuItem(hMenuWin, 121, MF_BYCOMMAND or MF_UNCHECKED);

if fRedrawP then InvalidateRgn(hWin, 0, TRUE);
end;  // TMyWindow.ToggleView3D

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// Handles the menu messages
Var wNrMenu     : word;
begin
WMCommand := 0; // Default return value when processing a message

if (lPar <> 0) then begin
   // call the parent WMCommand method.
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;

// for the menus,  lPar = 0
//=========================
wNrMenu   := LoWord(wPar);
Case wNrMenu Of
    51 : NewSpaceWorld;
   101 : ASurface;
   102 : ATorus;
   103 : AnEllipsoide;
   104 : ACube;
   105 : ATwistedTorus;
   106 : AMobiusRibbon;
   107 : ASpecialTorus;
   110 : SimpleSphere;
   111 : SimpleTetrahedron;
   112 : SimpleCube;
   113 : SimpleOctahedron;
   114 : SimpleDodecahedron;
   115 : SimpleIcosahedron;
   122 : SimpleCubeFull;
   131 : TruncatedCubeFull;
   132 : TruncatedTetrahedronFull;
   133 : TruncatedOctahedronFull;
   134 : SnubCubeFull;

   231 : TruncatedCubeEdges;

   190 : TestZ;

   201 : ToggleView3D(TRUE);

   // Indicate just to use the right click for more help and a menu
   301 : DialogExecMSG(12199, @Self);

   else WMCommand:=inherited WMCommand(wPar, lPar);
   end;  // Case NrMenu Of
end;  // TMyWindow.WMCommand

function TMyWindow.WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT;
//======================================================================================
begin

if (wMsg = WM_SETFOCUS) then begin
   if (poDraw3D^.hWin > 0) then  SetFocus(poDraw3D^.hWin);
   WindowProc:=0;
   exit;
   end;

// Default treatment of a message. Does nearly nothing
WindowProc := inherited WindowProc(hWindow, wMsg, wPar, lPar);
end;  // TMyWindow.WindowProc

Begin // MAIN ******
// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example057');

// Creation of the main window
new(poMyMainWin, Init('tEx057. Testing the 3D drawings (wDraw3DFrame0.pp)'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.

